/* ***********************************************************
 * This file was automatically generated on 2019-09-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * Measures weight with a load cell
 */
public class BrickletLoadCell extends Device {
	public final static int DEVICE_IDENTIFIER = 253;
	public final static String DEVICE_DISPLAY_NAME = "Load Cell Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "loadcell", DEVICE_IDENTIFIER, BrickletLoadCell.class);

	public final static byte FUNCTION_GET_WEIGHT = (byte)1;
	public final static byte FUNCTION_SET_WEIGHT_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_WEIGHT_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_SET_MOVING_AVERAGE = (byte)8;
	public final static byte FUNCTION_GET_MOVING_AVERAGE = (byte)9;
	public final static byte FUNCTION_LED_ON = (byte)10;
	public final static byte FUNCTION_LED_OFF = (byte)11;
	public final static byte FUNCTION_IS_LED_ON = (byte)12;
	public final static byte FUNCTION_CALIBRATE = (byte)13;
	public final static byte FUNCTION_TARE = (byte)14;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)15;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_WEIGHT = 17;
	private final static int CALLBACK_WEIGHT_REACHED = 18;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static short RATE_10HZ = (short)0;
	public final static short RATE_80HZ = (short)1;
	public final static short GAIN_128X = (short)0;
	public final static short GAIN_64X = (short)1;
	public final static short GAIN_32X = (short)2;

	private List<WeightListener> listenerWeight = new CopyOnWriteArrayList<WeightListener>();
	private List<WeightReachedListener> listenerWeightReached = new CopyOnWriteArrayList<WeightReachedListener>();

	public class WeightCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class Configuration {
		public short rate;
		public short gain;

		public String toString() {
			return "[" + "rate = " + rate + ", " + "gain = " + gain + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletLoadCell#setWeightCallbackPeriod(long)}. The parameter is the weight
	 * as measured by the load cell.
	 * 
	 * The {@link BrickletLoadCell.WeightListener} listener is only triggered if the weight has changed since the
	 * last triggering.
	 */
	public interface WeightListener extends DeviceListener {
		public void weight(int weight);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletLoadCell#setWeightCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the weight as measured by the load cell.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletLoadCell#setDebouncePeriod(long)}.
	 */
	public interface WeightReachedListener extends DeviceListener {
		public void weightReached(int weight);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLoadCell(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_WEIGHT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WEIGHT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_WEIGHT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MOVING_AVERAGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOVING_AVERAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_LED_ON)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_LED_OFF)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_LED_ON)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_CALIBRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_TARE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_WEIGHT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int weight = (bb.getInt());

				for (WeightListener listener: listenerWeight) {
					listener.weight(weight);
				}
			}
		};

		callbacks[CALLBACK_WEIGHT_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int weight = (bb.getInt());

				for (WeightReachedListener listener: listenerWeightReached) {
					listener.weightReached(weight);
				}
			}
		};
	}

	/**
	 * Returns the currently measured weight in grams.
	 * 
	 * If you want to get the weight periodically, it is recommended
	 * to use the {@link BrickletLoadCell.WeightListener} listener and set the period with
	 * {@link BrickletLoadCell#setWeightCallbackPeriod(long)}.
	 */
	public int getWeight() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_WEIGHT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int weight = (bb.getInt());

		return weight;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletLoadCell.WeightListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletLoadCell.WeightListener} listener is only triggered if the weight has changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setWeightCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WEIGHT_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletLoadCell#setWeightCallbackPeriod(long)}.
	 */
	public long getWeightCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_WEIGHT_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletLoadCell.WeightReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the weight is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the weight is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the weight is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the weight is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * The default value is ('x', 0, 0).
	 */
	public void setWeightCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletLoadCell#setWeightCallbackThreshold(char, int, int)}.
	 */
	public WeightCallbackThreshold getWeightCallbackThreshold() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		WeightCallbackThreshold obj = new WeightCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period in ms with which the threshold listener
	 * 
	 * * {@link BrickletLoadCell.WeightReachedListener}
	 * 
	 * is triggered, if the threshold
	 * 
	 * * {@link BrickletLoadCell#setWeightCallbackThreshold(char, int, int)}
	 * 
	 * keeps being reached.
	 * 
	 * The default value is 100.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletLoadCell#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
	 * for the weight value.
	 * 
	 * Setting the length to 1 will turn the averaging off. With less
	 * averaging, there is more noise on the data.
	 * 
	 * The range for the averaging is 1-40.
	 * 
	 * The default value is 4.
	 */
	public void setMovingAverage(short average) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_MOVING_AVERAGE, this);

		bb.put((byte)average);

		sendRequest(bb.array());
	}

	/**
	 * Returns the length moving average as set by {@link BrickletLoadCell#setMovingAverage(short)}.
	 */
	public short getMovingAverage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOVING_AVERAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short average = IPConnection.unsignedByte(bb.get());

		return average;
	}

	/**
	 * Turns the LED on.
	 */
	public void ledOn() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_LED_ON, this);


		sendRequest(bb.array());
	}

	/**
	 * Turns the LED off.
	 */
	public void ledOff() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_LED_OFF, this);


		sendRequest(bb.array());
	}

	/**
	 * Returns *true* if the led is on, *false* otherwise.
	 */
	public boolean isLEDOn() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_LED_ON, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean on = (bb.get()) != 0;

		return on;
	}

	/**
	 * To calibrate your Load Cell Bricklet you have to
	 * 
	 * * empty the scale and call this function with 0 and
	 * * add a known weight to the scale and call this function with the weight in
	 *   grams.
	 * 
	 * The calibration is saved in the EEPROM of the Bricklet and only
	 * needs to be done once.
	 * 
	 * We recommend to use the Brick Viewer for calibration, you don't need
	 * to call this function in your source code.
	 */
	public void calibrate(long weight) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_CALIBRATE, this);

		bb.putInt((int)weight);

		sendRequest(bb.array());
	}

	/**
	 * Sets the currently measured weight as tare weight.
	 */
	public void tare() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_TARE, this);


		sendRequest(bb.array());
	}

	/**
	 * The measurement rate and gain are configurable.
	 * 
	 * The rate can be either 10Hz or 80Hz. A faster rate will produce more noise.
	 * It is additionally possible to add a moving average
	 * (see {@link BrickletLoadCell#setMovingAverage(short)}) to the measurements.
	 * 
	 * The gain can be 128x, 64x or 32x. It represents a measurement range of
	 * ±20mV, ±40mV and ±80mV respectively. The Load Cell Bricklet uses an
	 * excitation voltage of 5V and most load cells use an output of 2mV/V. That
	 * means the voltage range is ±15mV for most load cells (i.e. gain of 128x
	 * is best). If you don't know what all of this means you should keep it at
	 * 128x, it will most likely be correct.
	 * 
	 * The configuration is saved in the EEPROM of the Bricklet and only
	 * needs to be done once.
	 * 
	 * We recommend to use the Brick Viewer for configuration, you don't need
	 * to call this function in your source code.
	 * 
	 * The default rate is 10Hz and the default gain is 128x.
	 */
	public void setConfiguration(short rate, short gain) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)rate);
		bb.put((byte)gain);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletLoadCell#setConfiguration(short, short)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.rate = IPConnection.unsignedByte(bb.get());
		obj.gain = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Weight listener.
	 */
	public void addWeightListener(WeightListener listener) {
		listenerWeight.add(listener);
	}

	/**
	 * Removes a Weight listener.
	 */
	public void removeWeightListener(WeightListener listener) {
		listenerWeight.remove(listener);
	}

	/**
	 * Adds a WeightReached listener.
	 */
	public void addWeightReachedListener(WeightReachedListener listener) {
		listenerWeightReached.add(listener);
	}

	/**
	 * Removes a WeightReached listener.
	 */
	public void removeWeightReachedListener(WeightReachedListener listener) {
		listenerWeightReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletLoadCell.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLoadCell.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLoadCellConfig cfg = (BrickletLoadCellConfig) config.as(BrickletLoadCellConfig.class);
        this.addWeightListener((weight) -> {if(true) {updateStateFn.accept("LoadCellWeight", transformLoadCellWeightCallback0(weight, cfg));}});
        this.setMovingAverage(cfg.movingAverage.shortValue());
		{
		BrickletLoadCellWeightConfig channelCfg = getChannelConfigFn.apply("LoadCellWeight").as(BrickletLoadCellWeightConfig.class);
		this.setWeightCallbackPeriod(channelCfg.updateInterval);
		this.setWeightCallbackThreshold('x', 0, 0);
		}
		{
		BrickletLoadCellTareConfig channelCfg = getChannelConfigFn.apply("LoadCellTare").as(BrickletLoadCellTareConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletLoadCellConfig cfg = (BrickletLoadCellConfig) config.as(BrickletLoadCellConfig.class);
        this.listenerWeight.clear();
        this.setWeightCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLoadCellConfig cfg = (BrickletLoadCellConfig) config.as(BrickletLoadCellConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("LoadCellWeight");
		result.add("LoadCellTare");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "LoadCellWeight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LoadCellWeight"), "Weight", "Number:Mass").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LoadCellWeight")).withDescription("The currently measured weight")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "LoadCellTare":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LoadCellTare"), "Tare", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LoadCellTare")).withDescription("Sets the currently measured weight as tare weight.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TARE", "Tare")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Load Cell Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures weight with a load cell").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("LoadCellWeight", new ChannelTypeUID("tinkerforge", "LoadCellWeight")).build(), new ChannelDefinitionBuilder("LoadCellTare", new ChannelTypeUID("tinkerforge", "LoadCellTare")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:loadcell":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("movingAverage", Type.INTEGER).withDefault("4").withDescription("The length of a moving averaging for the weight value.<br/><br/>Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.").withLabel("Moving Average").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(100)).build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:LoadCellWeight":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:LoadCellTare":
                return new ConfigDescription(uri, Arrays.asList());
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLoadCellConfig cfg = (BrickletLoadCellConfig) config.as(BrickletLoadCellConfig.class);
        switch(value) {
            case "LoadCellWeight": {
                   BrickletLoadCellWeightConfig channelCfg = channelConfig.as(BrickletLoadCellWeightConfig.class);
                   updateStateFn.accept(value, transformLoadCellWeightGetter0(this.getWeight(), cfg));
                   return;
               }
            case "LoadCellTare":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletLoadCellConfig cfg = (BrickletLoadCellConfig) config.as(BrickletLoadCellConfig.class);
        switch(channel) {
            case "LoadCellTare":
                if (command instanceof StringType) {
                    BrickletLoadCellTareConfig channelCfg = channelConfig.as(BrickletLoadCellTareConfig.class);
                    StringType cmd = (StringType) command;
                    this.tare();
                    result.add(new SetterRefresh("LoadCellWeight", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformLoadCellWeightCallback0(int weight, BrickletLoadCellConfig cfg) {
        return new QuantityType<>(weight, SIUnits.GRAM);
    }
	    private org.eclipse.smarthome.core.types.State transformLoadCellWeightGetter0(int value, BrickletLoadCellConfig cfg) {
        return new QuantityType<>(value, SIUnits.GRAM);
    }
}
